package hearts.model;

import hearts.util.Card;
import hearts.util.CardList;

/**
 * Stores a list of up to 13 rounds. Works with player names instead of players
 * to prevent users access to player state.
 */
public class Game
{
	/**
	 * @return A reference to a version of this objects that does not 
	 * allow classes outside this package to modify the state of the game
	 * or any object transitively reachable through it.
	 */
	public IImmutableGameState getImmutableState()
	{
		return null;
	}
	
	/**
	 * Resets the game to a new, empty state.
	 */
	public void clear()
	{
	}
	
	/**
	 * @return The trick currently being played.
	 */
	public Trick getCurrentTrick()
	{
		return null;
	}
	
	/**
	 * @return The number of tricks completed (4 cards played).
	 */
	public int tricksCompleted()
	{
		return 0;
	}
	
	/**
	 * @return The name of the winner of the last complete trick.
	 */
	public String getLastWinner()
	{
		return null;
	}
	
	/**
	 * @return true if a Hearts card has been played so far.
	 */
	public boolean heartsPlayed()
	{
		return false;
	}
	
	/**
	 * Adds a new, empty trick to the game stack.
	 */
	public void newTrick()
	{
	}
	
	/**
	 * Returns all the cards accumulated by a player by winning tricks.
	 * @param pPlayer The name of the player to query.
	 * @return All the cards won by the player.
	 */
	public CardList getCardsAccumulated(String pPlayer)
	{
		return null;
	}
	
	/**
	 * Returns the current score of a player in this game. 
	 * @param pPlayer The name of the player to query.
	 * @return The trick score accumulated in this game.
	 */
	public int getScore(String pPlayer)
	{
		return 0;
	}
	
	/**
	 * Adds a play to the current trick.
	 * @param pPlayer The name of the player making the play.
	 * @param pCard The card played by the player.
	 */
	public void addPlay(String pPlayer, Card pCard)
	{
	}
	
	/**
	 * @return The suit led in this trick.
	 * @throws ModelException If there is no play (so no suit was led).
	 */
	public Card.Suit getSuitLed() throws ModelException
	{
		return null;
	}
}
